/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
 import java.util.Vector;

class Snake {
	private SnakeHead head;
	private SnakeBody body;
	
	public Snake(Coord headPos) {
		head = new SnakeHead(headPos);
		body = new SnakeBody();
	}
	
	//places the head of the snake there, ehere is nothing
	public void place(JSLevel l) {
		Coord c = Coord.randCoord(Coord.getZeroCoord(), new Coord(Globals.SIZE_X, Globals.SIZE_Y, l.getNumLayers()).add(new Coord(-1,-1,-1)));
		while ( (l.getLayer(c) != 0) ||
		         l.isAppleAt(c))
			c = Coord.randCoord(Coord.getZeroCoord(), new Coord(Globals.SIZE_X, Globals.SIZE_Y, l.getNumLayers()).add(new Coord(-1,-1,-1)));
		setHeadPos(c);
	}
	public void clear() {
		body = new SnakeBody();
	}
	
	public void move(Coord dir) {
		body.move(head.getPos());
		head.setPos(head.getPos().add(dir));
	}
	
	public void grow(Coord crd) {
		body.addElement(crd);
	}
	public void setHeadTexture(int text) {
		head.setTexture(text);
	}
	
	public int getHeadTexture() {
		return head.getTexture();
	}
	
	public void setHeadPos(Coord pos) {
		head.setPos(pos);
	}
	
	public Coord getHeadPos() {
		return head.getPos();
	}
	
	public Coord getBodyPos() {
		return body.getPos();
	}
	
	public Coord getPrevBodyPos() {
		return body.getPrevPos();
	}
	
	public Coord getNextBodyPos() {
		return body.getNextPos();
	}
	
	//set the texture for the body element that will be moved next time
	public void setBodyTexture(int text) {
		body.setCurTexture(text);
	}
	
	public Vector<SnakeElement> getBodyElements() {
		return body.getSnakeElements();
	}
}